=== modified file 'console/console.js'
--- console/console.js	2008-01-02 04:45:20 +0000
+++ console/console.js	2008-01-02 22:05:22 +0000
@@ -135,17 +135,28 @@
     xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
     xmlhttp.send(make_post_body({"digest":digest, "text":inp.value}))
     var res = JSON.parse(xmlhttp.responseText);
-    var output = document.getElementById("outputArea")
-    output.appendChild(document.createTextNode(inp.value + "\n"));
+    var output = document.getElementById("output")
+    {
+        var pre = document.createElement("pre");
+        pre.setAttribute("class", "inputMsg");
+        pre.appendChild(document.createTextNode(inp.value + "\n"));
+        output.appendChild(pre);
+    }
     if (res && res[0])
     {
         // Success!
         // print out the output (res[0])
-        output.appendChild(document.createTextNode(res[0]));
+        var pre = document.createElement("pre");
+        pre.setAttribute("class", "outputMsg");
+        pre.appendChild(document.createTextNode(res[0]));
+        output.appendChild(pre);
         // print out the return value (res[1])
         if (res[1])
         {
-            output.appendChild(document.createTextNode(res[1] + "\n"));
+            var pre = document.createElement("pre");
+            pre.setAttribute("class", "outputMsg");
+            pre.appendChild(document.createTextNode(res[1] + "\n"));
+            output.appendChild(pre);
         }
         // set the prompt to >>>
         var prompt = document.getElementById("prompt");
@@ -155,7 +166,10 @@
     {
         // Failure!
         // print out the error message (res[2])
-        output.appendChild(document.createTextNode(res[2]));
+        var pre = document.createElement("pre");
+        pre.setAttribute("class", "errorMsg");
+        pre.appendChild(document.createTextNode(res[2]));
+        output.appendChild(pre);
     }
     else
     {
@@ -172,14 +186,16 @@
     {
         enter_line();
         hist.add(inp.value);
+        inp.value = hist.curr();
     }
     if (key == 38)
     {
         hist.up();
+        inp.value = hist.curr();
     }
     if (key == 40)
     {
         hist.down();
+        inp.value = hist.curr();
     }
-    inp.value = hist.curr();
 }

=== modified file 'console/index.html'
--- console/index.html	2008-01-02 04:45:20 +0000
+++ console/index.html	2008-01-02 22:05:22 +0000
@@ -12,12 +12,7 @@
         height: 24em;
         overflow: scroll;
         margin-bottom: 4pt;
-    }
-    #errors {
-        border: solid red 1pt;
-        height: 6em;
-        overflow: scroll;
-        margin-bottom: 4pt;
+        padding: 4pt;
     }
     #input {
         border: solid green 1pt;
@@ -25,17 +20,28 @@
     #prompt {
         font-family: monospace;
     }
+    pre.errorMsg {
+        color: red;
+        margin-top: 0em;
+        margin-bottom: 0em;
+    }
+    pre.inputMsg {
+        color: gray;
+        margin-top: 0em;
+        margin-bottom: 0em;
+    }
+    pre.outputMsg {
+        margin-top: 0em;
+        margin-bottom: 0em;
+    }
   </style>
  </head>
  <body>
   <div id='output'>
-    <pre id='outputArea'></pre>
-  </div>
-  <div id='errors'>
-    <pre id='errorArea'></pre>
   </div>
   <div id='input'>
-    <pre id='inputArea'></pre>
+   <div id='inputArea'>
+   </div>
    <label id='prompt'>&gt;&gt;&gt;&nbsp;</label><input id='inputText' type='text' size='80' onkeypress='catch_input(event.keyCode)'/>
   </div>
  </body>

